<?php
/**
 *
 * @package	    Pay My Bill Module
 * @subpackage	Pay My Bill Module
 * @version     1.0.0
 * @description Pay My Bill Module
 * @copyright	  Copyright © 2013 - All rights reserved.
 * @license		  GNU General Public License v2.0
 * @author		  SoftPill.Eu
 * @author mail	mail@softpill.eu
 * @website		  www.softpill.eu
 *
 */
//ini_set("display_errors",0);
//error_reporting(E_ALL);

// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

class PMBcashu
{
  function checkMethod($params)
  {
    $vendor_missing=JText::_( 'PMB_CASHU_MODULE_ERR_VENDOR' );
    $password_missing=JText::_( 'PMB_CASHU_MODULE_ERR_PASS' );
    $vendor_name=trim($params->get('cashu_user'));
    $vendor_password=trim($params->get('cashu_password'));
    
    if($vendor_name=='')
    {
      ?>
        <div class="pmb_error"><?php echo $vendor_missing;?></div>
      <?php
      return false;
    }
    else if($vendor_password=='')
    {
      ?>
        <div class="pmb_error"><?php echo $password_missing;?></div>
      <?php
      return false;
    }

    return true;
  }
  function getPMBDomain()
  {
    $domain=str_ireplace("www.","",$_SERVER['HTTP_HOST']);
    $is_ip = ip2long($domain) !== false;
    if($is_ip)
    {
      return false;
    }
    else if(trim($domain)=='')
    {
      return false;
    }
    
    return $domain;
  }
  function doPayment($params,$details,$all_params)
  {
    /*
    $dchk=$all_params['dchk'];
    $lic=$all_params['pmblic'];
    $the_domain=$this->getPMBDomain();
    if($the_domain)
    {
      $chk=md5($lic.$the_domain);
      if($dchk!=$chk)
      {
        echo '<font color="red"><strong>'.JText::_( 'PMB_MODULE_LICENSE_ERR' ).'</strong></font>';
        exit;
      }
    }
    */
    $product_name=$params->get('product_name');
    $invoice_field=$params->get('show_inv_field');
    $cost_per_transaction=$params->get('cashu_trans_cost')+0;
    $percent_per_transaction=$params->get('cashu_trans_percent_cost')+0;
    
    $vendor_name=trim($params->get('cashu_user'));
    $vendor_password=trim($params->get('cashu_password'));
    $language=$params->get('cashu_language');
    $mode=$params->get('cashu_mode');
    $currency=$params->get('cashu_currency');
    
    $details['subtotal']=$details['payment'];
    $payment=$details['payment'];
    if($cost_per_transaction>0)
    {
      $payment+=$cost_per_transaction;
    }
    if($percent_per_transaction>0)
    {
      $payment=$payment+($payment*$percent_per_transaction);
    }
    
    $payment=round($payment,2);
    $payment=number_format($payment,2);
    $details['payment']=$payment;
    $details['mode']=$mode;
    $details['currency']=$currency;
    if($params->get('mail_pending')!=0)
    {
      require_once(JPATH_BASE.DS."modules".DS."mod_paymybill".DS."functions".DS."functions.php");
      $pmbf=new PMBFunctions();
      $pmbf->sendConfirmationMail("pending",$all_params,$details,'CashU');//send pending mail
    }
    $pmbf->saveOrder($payment,$mode,$all_params,$details,'CashU');
    
    $test_mode=0;
    $MerchantId = $vendor_name;
    if($mode=='TEST')
	  {
	    $test_mode=1;
	  }

    $Amount = $payment;
    $keyword = $vendor_password;
    $token=md5(strtolower($MerchantId). ":" .$Amount. ":" .strtolower($currency). ":" .$keyword);
    
    $PaymentDescription=$product_name.' at '.$_SERVER['HTTP_HOST'].' order.';
    
    if($invoice_field)
    {
      $PaymentDescription=$product_name.' at '.$_SERVER['HTTP_HOST'].' for '.$details['InvNr'];
    }

    $post_variables=array(
    'merchant_id'=>$MerchantId,
    'token'=>$token,
    'session_id'=>$details['order_id'],
    'test_mode'=>$test_mode,
    'display_text'=>$PaymentDescription,
    'language'=>$language,
    'txt1'=>$PaymentDescription,
    'amount'=>$Amount,
    'currency'=>$currency,
    'billing_cust_name'=>$details['BillFname'],
  	'billing_last_name'=>$details['BillLname'],
  	'billing_cust_address'=>$details['BillAddr'],
  	'billing_cust_city'=>$details['BillCity'],
  	'billing_cust_country'=>$details['BillCountry'],
  	'billing_cust_zip'=>$details['BillZip'],
    'billing_cust_state'=>$details['BillState'],
  	'billing_cust_tel_No'=>$details['BillPhone'],
  	'billing_cust_email'=>$details['BillEmail'],
  	'delivery_cust_name'=>$details['BillFname'],
  	'delivery_last_name'=>$details['BillLname'],
  	'delivery_cust_address'=>$details['BillAddr'],
  	'delivery_cust_city'=>$details['BillCity'],
  	'delivery_cust_country'=>$details['BillCountry'],
  	'delivery_cust_zip'=>$details['BillZip'],
    'delivery_cust_state'=>$details['BillState'],
  	'delivery_cust_tel_No'=>$details['BillPhone']
    );

    $the_url='https://www.cashu.com/cgi-bin/pcashu.cgi';
    
    $pmb_button='Redirecting to payment page';
    
    $html = '<html><head><title>Redirection</title></head><body><div style="margin: auto; text-align: center;">';
		$html.= "\n".'<form name="PMBfrm" id="PMBfrm" action="'.$the_url.'" method="post">';
	  foreach ($post_variables as $name => $value) {
			$html .= '
      <input type="hidden" name="' . $name . '" value="' . htmlspecialchars ($value) . '" />';
		}
		$html.= '<input type="submit"  value="'.$pmb_button.'" />';
		$html.= '</form></div>';
		$html.= ' <script type="text/javascript">';
		$html.= ' document.PMBfrm.submit();';
		$html.= ' </script></body></html>';
    
    ob_end_clean();
    
    echo $html;exit;
  }
}
?>