<?php
/**
 *
 * @package	    Pay My Bill Module
 * @subpackage	Pay My Bill Module
 * @version     1.0.0
 * @description Pay My Bill Module
 * @copyright	  Copyright © 2013 - All rights reserved.
 * @license		  GNU General Public License v2.0
 * @author		  SoftPill.Eu
 * @author mail	mail@softpill.eu
 * @website		  www.softpill.eu
 *
 */
//ini_set("display_errors",0);
//error_reporting(E_ALL);

// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

class PMBpayulatam
{
  function checkMethod($params)
  {
    $vendor_missing=JText::_( 'PMB_PAYULATAM_MODULE_ERR_VENDOR' );
    $password_missing=JText::_( 'PMB_PAYULATAM_MODULE_ERR_PASS' );
    $vendor_name=trim($params->get('payulatam_user'));
    $vendor_password=trim($params->get('payulatam_password'));
    
    if($vendor_name=='')
    {
      ?>
        <div class="pmb_error"><?php echo $vendor_missing;?></div>
      <?php
      return false;
    }
    else if($vendor_password=='')
    {
      ?>
        <div class="pmb_error"><?php echo $password_missing;?></div>
      <?php
      return false;
    }

    return true;
  }
  function getPMBDomain()
  {
    $domain=str_ireplace("www.","",$_SERVER['HTTP_HOST']);
    $is_ip = ip2long($domain) !== false;
    if($is_ip)
    {
      return false;
    }
    else if(trim($domain)=='')
    {
      return false;
    }
    
    return $domain;
  }
  function doPayment($params,$details,$all_params)
  {
    /*
    $dchk=$all_params['dchk'];
    $lic=$all_params['pmblic'];
    $the_domain=$this->getPMBDomain();
    if($the_domain)
    {
      $chk=md5($lic.$the_domain);
      if($dchk!=$chk)
      {
        echo '<font color="red"><strong>'.JText::_( 'PMB_MODULE_LICENSE_ERR' ).'</strong></font>';
        exit;
      }
    }
    */
    $product_name=$params->get('product_name');
    $invoice_field=$params->get('show_inv_field');
    $cost_per_transaction=$params->get('payulatam_trans_cost')+0;
    $percent_per_transaction=$params->get('payulatam_trans_percent_cost')+0;
    
    $vendor_name=trim($params->get('payulatam_user'));
    $vendor_password=trim($params->get('payulatam_password'));
    $vendor_password2=trim($params->get('payulatam_password2'));
    $language=$params->get('payulatam_language');
    $mode=$params->get('payulatam_mode');
    $currency=$params->get('payulatam_currency');
    
    $details['subtotal']=$details['payment'];
    $payment=$details['payment'];
    if($cost_per_transaction>0)
    {
      $payment+=$cost_per_transaction;
    }
    if($percent_per_transaction>0)
    {
      $payment=$payment+($payment*$percent_per_transaction);
    }
    
    $payment=round($payment,2);
    //$payment=number_format($payment,2);
    $details['payment']=$payment;
    $details['mode']=$mode;
    $details['currency']=$currency;
    if($params->get('mail_pending')!=0)
    {
      require_once(JPATH_BASE.DS."modules".DS."mod_paymybill".DS."functions".DS."functions.php");
      $pmbf=new PMBFunctions();
      $pmbf->sendConfirmationMail("pending",$all_params,$details,'PayuLatam');//send pending mail
    }
    $pmbf->saveOrder($payment,$mode,$all_params,$details,'PayuLatam');
    $PaymentDescription=$product_name.' at '.$_SERVER['HTTP_HOST'].' order.';
    
    if($invoice_field)
    {
      $PaymentDescription=$product_name.' at '.$_SERVER['HTTP_HOST'].' for '.$details['InvNr'];
    }
    $signature=md5("$vendor_password~$vendor_name~".$details['order_id']."~$payment~$currency");
    
    $return_url=JROUTE::_(JURI::root()."modules/mod_paymybill/return/payulatam_return.php");
    $notify_url=JROUTE::_(JURI::root()."modules/mod_paymybill/return/payulatam_notify.php");
    
    $post_variables = Array
    (
    "merchantId"=>$vendor_name,
    "lng"=>$language,
    "referenceCode"=>$details['order_id'],
    "accountId"=>$vendor_password2,
    "description"=>$PaymentDescription,
    "amount"=>$payment,
    "tax"=>0,
    "taxReturnBase"=>0,
    "signature"=>$signature,
    "currency"=>$currency,
    "buyerEmail"=>$details['BillEmail'],
    "payerFullName"=>$details['BillFname'] . " " . $details['BillLname'],
    "billingAddress"=>$details['BillAddr'],
    "shippingAddress"=>$details['BillAddr'],
    "telephone"=>$details['BillPhone'],
    "billingCity"=>$details['BillCity'],
    "shippingCity"=>$details['BillCity'],
    "zipCode"=>$details['BillZip'],
    "billingCountry"=>$details['BillCountry'],
    "shippingCountry"=>$details['BillCountry'],
    "buyerFullName"=> $details['BillFname'] . " " . $details['BillLname'],
    "payerEmail"=>$details['BillEmail'],
    "payerPhone"=>$details['BillPhone'],
    "responseUrl"=>$return_url,
    "confirmationUrl"=>$notify_url
    );
    $url='https://gateway.payulatam.com/ppp-web-gateway/';
    if($mode=='TEST')
	  {
	    $post_variables["test"]=1;
      $url='https://stg.gateway.payulatam.com/ppp-web-gateway';
	  }
    
    $pmb_button='Redirecting to payment page';
    
    $html = '<html><head><title>Redirection</title></head><body><div style="margin: auto; text-align: center;">';
		$html.= "\n".'<form name="PMBfrm" id="PMBfrm" action="'.$url.'" method="post">';
	  foreach ($post_variables as $name => $value) {
			$html.= '
      <input type="hidden" name="' . $name . '" value="' . htmlspecialchars($value) . '" />';
		}
		$html.= '<input type="submit"  value="'.$pmb_button.'" />';
		$html.= '</form></div>';
    		
		$html.= ' <script type="text/javascript">';
		$html.= ' document.PMBfrm.submit();';
		$html.= ' </script></body></html>';
    
    ob_end_clean();
    
    echo $html;exit;
  }
}
?>