<?php
/**
 *
 * @package	    Pay My Bill Module
 * @subpackage	Pay My Bill Module
 * @version     1.0.0
 * @description Pay My Bill Module
 * @copyright	  Copyright © 2013 - All rights reserved.
 * @license		  GNU General Public License v2.0
 * @author		  SoftPill.Eu
 * @author mail	mail@softpill.eu
 * @website		  www.softpill.eu
 *
 */
//ini_set("display_errors",0);
//error_reporting(E_ALL);

// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );
class PMBcardstream
{
  function checkMethod($params)
  {
    $vendor_missing=JText::_( 'PMB_CARDSTREAM_ERR_VENDOR' );
    $password_missing=JText::_( 'PMB_CARDSTREAM_ERR_PASS' );
    $vendor_name=trim($params->get('cardstream_user'));
    $vendor_password=trim($params->get('cardstream_password'));
    
    if($vendor_name=='')
    {
      ?>
        <div class="pmb_error"><?php echo $vendor_missing;?></div>
      <?php
      return false;
    }
    else if($vendor_password=='')
    {
      ?>
        <div class="pmb_error"><?php echo $password_missing;?></div>
      <?php
      return false;
    }

    return true;
  }
  function getPMBDomain()
  {
    $domain=str_ireplace("www.","",$_SERVER['HTTP_HOST']);
    $is_ip = ip2long($domain) !== false;
    if($is_ip)
    {
      return false;
    }
    else if(trim($domain)=='')
    {
      return false;
    }
    
    return $domain;
  }
  function doPayment($params,$details,$all_params)
  {
    /*
    $dchk=$all_params['dchk'];
    $lic=$all_params['pmblic'];
    $the_domain=$this->getPMBDomain();
    if($the_domain)
    {
      $chk=md5($lic.$the_domain);
      if($dchk!=$chk)
      {
        echo '<font color="red"><strong>'.JText::_( 'PMB_MODULE_LICENSE_ERR' ).'</strong></font>';
        exit;
      }
    }
    */
    $product_name=$params->get('product_name');
    $invoice_field=$params->get('show_inv_field');
    $cost_per_transaction=$params->get('cardstream_trans_cost')+0;
    $percent_per_transaction=$params->get('cardstream_trans_percent_cost')+0;
    
    $vendor_name=trim($params->get('cardstream_user'));
    $vendor_password=trim($params->get('cardstream_password'));
    $mode='LIVE';
    if($vendor_name=='100001')
    {
      $mode='TEST';
    }
    $currency=$params->get('cardstream_currency');
    
    $details['subtotal']=$details['payment'];
    $payment=$details['payment'];
    if($cost_per_transaction>0)
    {
      $payment+=$cost_per_transaction;
    }
    if($percent_per_transaction>0)
    {
      $payment=$payment+($payment*$percent_per_transaction);
    }
    
    $payment=round($payment,2);
    $payment=number_format($payment,2);
    $details['payment']=$payment;
    $details['mode']=$mode;
    $details['currency']=$currency;
    if($params->get('mail_pending')!=0)
    {
      require_once(JPATH_BASE.DS."modules".DS."mod_paymybill".DS."functions".DS."functions.php");
      $pmbf=new PMBFunctions();
      $pmbf->sendConfirmationMail("pending",$all_params,$details,'CardStream');//send pending mail
    }
    $pmbf->saveOrder($payment,$mode,$all_params,$details,'CardStream');
    
    $PaymentDescription=$product_name.' at '.$_SERVER['HTTP_HOST'].' order.';
    
    if($invoice_field)
    {
      $PaymentDescription=$product_name.' at '.$_SERVER['HTTP_HOST'].' for '.$details['InvNr'];
    }
    
    $redirect_url=JROUTE::_(JURI::root()."modules/mod_paymybill/return/cardstream_return.php");
    
    $post_variables=array(
    "merchantID" => $vendor_name, 
    "amount" => $payment, 
    "countryCode" => $details['BillCountry'], 
    "currencyCode" => $currency, 
    "transactionUnique" => $details['order_id'], 
    "orderRef" => $PaymentDescription, 
    "redirectURL" => $redirect_url,
    "item1Description"=>$PaymentDescription,
    "item1Quantity"=> 1,
    "item1GrossValue"=> $payment,
    "type"=>2,
    "action"=>'SALE',
    "customerName"=> $details['BillFname']." ".$details['BillLname'],
    "customerAddress"=> $details['BillAddr']." ".$details['BillCity'],
    "customerPostCode"=> $details['BillZip'],
    "customerEmail"=> $details['BillEmail'],
    "customerPhone"=> $details['BillPhone']
    );
    ksort($post_variables); 
    $signature=hash("SHA512", http_build_query($post_variables) . $vendor_password);
    
    $pmb_button='Redirecting to payment page';
    
    $html = '<html><head><title>Redirection</title></head><body><div style="margin: auto; text-align: center;">';
		$html.= "\n".'<form name="PMBfrm" id="PMBfrm" action="https://gateway.cardstream.com/hosted/" method="post">';
	  foreach ($post_variables as $name => $value) {
			$html .= '
      <input type="hidden" name="' . $name . '" value="' . htmlspecialchars ($value) . '" />';
		}
    $html .= '<input type="hidden" name="signature" value="' . htmlspecialchars ($signature) . '" />';
		$html.= '<input type="submit"  value="'.$pmb_button.'" />';
		$html.= '</form></div>';
		$html.= ' <script type="text/javascript">';
		$html.= ' document.PMBfrm.submit();';
		$html.= ' </script></body></html>';
    
    ob_end_clean();
    
    echo $html;exit;
  }
}
?>