<?php
/**
 *
 * @package	    Pay My Bill Module
 * @subpackage	Pay My Bill Module
 * @version     1.0.0
 * @description Pay My Bill Module
 * @copyright	  Copyright © 2013 - All rights reserved.
 * @license		  GNU General Public License v2.0
 * @author		  SoftPill.Eu
 * @author mail	mail@softpill.eu
 * @website		  www.softpill.eu
 *
 */
//ini_set("display_errors",0);
//error_reporting(E_ALL);

// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );
class PMBokpay
{
  function checkMethod($params)
  {
    $vendor_missing=JText::_( 'PMB_OKPAY_MODULE_ERR_VENDOR' );
    $vendor_name=trim($params->get('okpay_user'));
    
    if($vendor_name=='')
    {
      ?>
        <div class="pmb_error"><?php echo $vendor_missing;?></div>
      <?php
      return false;
    }

    return true;
  }
  function getPMBDomain()
  {
    $domain=str_ireplace("www.","",$_SERVER['HTTP_HOST']);
    $is_ip = ip2long($domain) !== false;
    if($is_ip)
    {
      return false;
    }
    else if(trim($domain)=='')
    {
      return false;
    }
    
    return $domain;
  }
  function doPayment($params,$details,$all_params)
  {
    /*
    $dchk=$all_params['dchk'];
    $lic=$all_params['pmblic'];
    $the_domain=$this->getPMBDomain();
    if($the_domain)
    {
      $chk=md5($lic.$the_domain);
      if($dchk!=$chk)
      {
        echo '<font color="red"><strong>'.JText::_( 'PMB_MODULE_LICENSE_ERR' ).'</strong></font>';
        exit;
      }
    }
    */
    $product_name=$params->get('product_name');
    $invoice_field=$params->get('show_inv_field');
    $cost_per_transaction=$params->get('okpay_trans_cost')+0;
    $percent_per_transaction=$params->get('okpay_trans_percent_cost')+0;
    
    $vendor_name=trim($params->get('okpay_user'));
    
    $mode='LIVE';
    $currency=$params->get('okpay_currency');
    
    $details['subtotal']=$details['payment'];
    $payment=$details['payment'];
    if($cost_per_transaction>0)
    {
      $payment+=$cost_per_transaction;
    }
    if($percent_per_transaction>0)
    {
      $payment=$payment+($payment*$percent_per_transaction);
    }
    
    $payment=round($payment,2);
    $payment=number_format($payment,2);
    $details['payment']=$payment;
    $details['mode']=$mode;
    $details['currency']=$currency;
    if($params->get('mail_pending')!=0)
    {
      require_once(JPATH_BASE.DS."modules".DS."mod_paymybill".DS."functions".DS."functions.php");
      $pmbf=new PMBFunctions();
      $pmbf->sendConfirmationMail("pending",$all_params,$details,'OkPay');//send pending mail
    }
    $pmbf->saveOrder($payment,$mode,$all_params,$details,'OkPay');
    $PaymentDescription=$product_name.' at '.$_SERVER['HTTP_HOST'].' order.';
    
    if($invoice_field)
    {
      $PaymentDescription=$product_name.' at '.$_SERVER['HTTP_HOST'].' for '.$details['InvNr'];
    }
    
    $success_url=JROUTE::_(JURI::root()."modules/mod_paymybill/return/okpay_return.php");
    $failure_url=JROUTE::_(JURI::root()."modules/mod_paymybill/return/okpay_failure.php?order_id=".$details['order_id']);
    $notify_url=JROUTE::_(JURI::root()."modules/mod_paymybill/return/okpay_notify.php");
    
    $post_variables=array(
    "ok_invoice"=>$details['order_id'],
    "ok_receiver"=>$vendor_name,
    "ok_item_1_name"=>$PaymentDescription,
    "ok_item_1_quantity"=>1,
    "ok_item_1_price"=>$payment,
    "ok_currency"=>$currency,
    "ok_payer_first_name"=>$details['BillFname'],
    "ok_payer_last_name"=>$details['BillLname'],
    "ok_payer_email"=>$details['BillEmail'],
    "ok_payer_country_code"=>$details['BillCountry'],
    "ok_payer_city"=>$details['BillCity'],
    "ok_payer_state"=>$details['BillState'],
    "ok_payer_street"=>$details['BillAddr'],
    "ok_payer_zip"=>$details['BillZip'],
    "ok_return_success"=>$success_url,
    "ok_return_fail"=>$failure_url,
    "ok_ipn"=>$notify_url
    );
    
    $OKPayHelper = new OKPayHelper();
    $url = $OKPayHelper->_getOkpayUrlHttps ($method);
    
    $pmb_button='Redirecting to payment page';
    
    $html = '<html><head><title>Redirection</title></head><body><div style="margin: auto; text-align: center;">';
		$html.= "\n".'<form name="PMBfrm" id="PMBfrm" action="'.$url.'" method="post">';
	  foreach ($post_variables as $name => $value) {
			$html .= '<input type="hidden" name="' . $name . '" value="' . htmlspecialchars ($value) . '" />';
		}
		$html.= '<input type="submit"  value="'.$pmb_button.'" />';
		$html.= '</form></div>';
		$html.= ' <script type="text/javascript">';
		$html.= ' document.PMBfrm.submit();';
		$html.= ' </script></body></html>';
    
    ob_end_clean();
    
    echo $html;exit;
  }
}
class OKPayHelper {

  function _getWalletID ($method) {
		echo '<pre style="font-size:12px;background:white;">';
		print_r($method);
		echo '</pre>';
		return /*$method->sandbox ? $method->sandbox_wallet_id : */ $method->okpay_wallet_id;
	}

	function _getOkpayUrl ($method) {
		$url = /*$method->sandbox ? 'www.sandbox.okpay.com' :*/ 'https://www.okpay.com';
		return $url;
	}

	function _getOkpayUrlHttps ($method) {
		$url = $this->_getOkpayUrl ($method);
		$url = $url . '/process.html';
		return $url;
	}

	/*
	 * CheckOKPayIPs
	 * Cannot be checked with Sandbox
	 * From VM1.1
	*/
	function checkOkpayIps ($test_ipn) {
		return;
	}
  function _processIPN ($okpay_data) {
		$secure_post = true;
		// read the post from okpay system and add 'cmd'
		$post_msg = 'ok_verify=true';
		foreach ($okpay_data as $key => $value) {
			if ($key != 'view' && $key != 'layout') {
				$value = urlencode ($value);
				$post_msg .= "&$key=$value";
			}
		}
    $okpay_url='okpay.com';
		// post back to okpay system to validate
		$header = "POST /ipn-verify.html HTTP/1.0\r\n";
		$header .= "Host: ".$okpay_url."\r\n"; 
		$header .= "Content-Type: application/x-www-form-urlencoded\r\n";
		$header .= "Content-Length: " . strlen ($post_msg) . "\r\n\r\n";
		
		if ($secure_post) {
			// If possible, securely post back to okpay using HTTPS
			// Your PHP server will need to be SSL enabled
			$fps = fsockopen ('ssl://' . $okpay_url, 443, $errno, $errstr, 30);
		} else {
			$fps = fsockopen ($okpay_url, 80, $errno, $errstr, 30);
		}
		
		if (!$fps) {
			return 'error';
		} else {
			fputs ($fps, $header . $post_msg);
			while (!feof ($fps)) {
				$res = fgets ($fps, 1024);
				if (strcmp ($res, 'VERIFIED') == 0) {
					return '';
				} elseif (strcmp ($res, 'INVALID') == 0) {
					$emailBody = "Hello,\n\nerror with okpay IPN NOTIFICATION" . " " . $res . "\n";
					// If 'INVALID', send an email. TODO: Log for manual investigation.
					foreach ($okpay_data as $key => $value) {
						$emailBody .= $key . " = " . $value . "\n";
					}
					return 'error2';
				}
			}
		}
		fclose ($fps);
		return '';
	}
}
?>